<?php

namespace Drupal\eca_push_framework\Event;

use Drupal\eca\Plugin\DataType\DataTransferObject;
use Drupal\eca\Token\DataProviderInterface;

/**
 * Provides the event that should directly push a notification.
 *
 * @internal
 *   This class is not meant to be used as a public API. It is subject for name
 *   change or may be removed completely, also on minor version updates.
 *
 * @package Drupal\eca_push_framework\Event
 */
class DirectPush extends BaseEvent implements DataProviderInterface {

  public function getData(string $key): ?DataTransferObject {
    return NULL;
  }

  public function hasData(string $key): bool {
    return ($key === '');
  }

}
