<?php

namespace Drupal\eca_push_framework\Plugin\ECA\Event;

use Drupal\eca\Plugin\ECA\Event\EventBase;
use Drupal\push_framework\ChannelEvents;
use Drupal\push_framework\Event\ChannelPostRender;
use Drupal\push_framework\Event\ChannelPreBuild;
use Drupal\push_framework\Event\ChannelPrepareTemplates;
use Drupal\push_framework\Event\ChannelPreRender;

/**
 * Plugin implementation of the ECA Events for the Push Framework.
 *
 * @EcaEvent(
 *   id = "push_framework_channel",
 *   deriver = "Drupal\eca_push_framework\Plugin\ECA\Event\ChannelEventDeriver"
 * )
 */
class ChannelEvent extends EventBase {

  /**
   * {@inheritdoc}
   */
  public static function definitions(): array {
    $events = [];
    $events['prepare_templates'] = [
      'label' => 'Prepare templates',
      'event_name' => ChannelEvents::PREPARE_TEMPLATES,
      'event_class' => ChannelPrepareTemplates::class,
    ];
    $events['pre_build'] = [
      'label' => 'Pre build notification',
      'event_name' => ChannelEvents::PRE_BUILD,
      'event_class' => ChannelPreBuild::class,
    ];
    $events['pre_render'] = [
      'label' => 'Pre render notification',
      'event_name' => ChannelEvents::PRE_RENDER,
      'event_class' => ChannelPreRender::class,
    ];
    $events['post_render'] = [
      'label' => 'Post render notification',
      'event_name' => ChannelEvents::POST_RENDER,
      'event_class' => ChannelPostRender::class,
    ];
    return $events;
  }

}
